/* MyCollectionTableView */

@class MyControllerShared, MyAddressBook, MOCollection;

enum {
	MKTableSizeSmall = 0,
	MKTableSizeLarge = 1,
	MKTableSizeTiny,
    MKTableSizeExtraLarge
};

@interface MyCollectionTableView : NSOutlineView <NSOutlineViewDelegate, NSOutlineViewDataSource> {
	IBOutlet MyControllerShared *controller;
	IBOutlet MyAddressBook *addressBook;
	
	IBOutlet NSView *splitViewLeft;
	IBOutlet NSTreeController *treeController;	
	
	float lastMouseXCordinates;

	//NSNumber *editedUID;
	//NSMutableArray *collectionsArray;
	
	//NSColor *collectionHeighlightColor, *collectionHeighlightFocusColor;
	//NSDictionary *selectedFontAttribute, *fontAttribute;
	//NSColor *blueOvalColor;
	//NSFont *boldControlFont;
	
	//NSClipView *contentView;
	//BOOL isFirstResponder;
	//NSPoint highlightPhasePoint;
	
	MOCollection *draggedCollection;
	MOCollection *libraryCollection, *borrowedCollection, *wishlistCollection; 
	
	//NSFont *writingFont, *writingFontBold;
    
    BOOL holdDelegateMessage; //Only used to avoid bug when dragging a collection into a folder while selected as the library gets selected for a second
    BOOL acceptFirstResponder;
}

@property (nonatomic, assign) BOOL holdDelegateMessage;


- (NSTreeController *)treeController;
- (void)expandURIs:(NSArray *)someURIs;

//- (void)setCollectionXML:(NSMutableArray *)incomingLists;
//- (NSString *)titleForRow:(int)row;
//- (NSImage *)imageForRow:(int)row;

//- (void)setEditedUID:(NSNumber *)aNumber;  //for finishing editing when returned is pressed
//- (void)sortCollections;

- (MOCollection *)selectedCollection;
- (MOCollection *)borrowedCollection;
- (MOCollection *)wishlistCollection;
- (MOCollection *)libraryCollection;
- (NSArray *)excludedCollections;
- (NSArray *)allCollections;
- (NSArray *)rootCollections;
- (NSArray *)collectionsOfType:(NSNumber *)aCollectionType;

- (MOCollection *)collectionWithName:(NSString *)aName excluded:(BOOL)isExcluded;

- (void)selectCollection:(MOCollection *)aCollection;
//- (void)selectCollectionWithUID:(NSNumber *)aUID;

- (IBAction)addNewGroupToCollections:(id)sender;

- (MOCollection *)createCollectionWithName:(NSString *)aName;  // Does not begin edit
- (IBAction)newNormalCollection:(id)sender;
- (IBAction)newCollectionWithSelection:(id)sender;
- (MOCollection *)createCollectionNamed:(NSString *)name withEntries:(NSSet *)aSet;
//- (void)newCollectionNamed:(NSString *)name withPossibleEntries:(NSSet *)aSet;
- (IBAction)newSmartCollection:(id)sender;
- (void)createSmartCollectionWithPredicate:(NSPredicate *)aPredicate andName:(NSString *)aName;
- (IBAction)editSmartCollection:(id)sender;
- (IBAction)deleteCollection:(id)sender;
- (void)deleteCollection:(MOCollection *)selectedCollection warn:(BOOL)showWarning;
- (IBAction)newWishlistCollection:(id)sender;
- (IBAction)newBorrowedCollection:(id)sender;
- (IBAction)toggleModertatorCollections:(id)sender;
- (IBAction)emptyAction:(id)sender;

- (IBAction)duplicate:(id)sender;

- (IBAction)toogleExcludedOnSelectedCollection:(id)sender;

- (IBAction)toggleCountColumn:(id)sender;
- (void)reloadCount;

- (void)setLargeSize:(NSInteger)large;

- (void)clearFetchedInstances;

- (void)updateSmartCollections:(id)sender;
- (void)updateSmartCollectionsForEntry:(MOEntry *)anEntry;




- (IBAction)newSharedCollectionFromURL:(NSString *)aURLString;
//- (void)updateSharedCollection:(MOCollection *)aCollection;
- (void)updateAllSharedCollections;
//- (IBAction)updateSelectedCollections:(id)sender;
- (void)updateAllSharedCollectionsThread;
- (NSArray *)allSharedCollectionsWithContext:(NSManagedObjectContext *)managedObjectContext;
- (void)updateSharedCollectionInThread:(NSManagedObjectID *)aCollectionID;
- (void)updateSharedCollection:(MOCollection *)aCollection withContext:(NSManagedObjectContext *)managedObjectContext;
@end
