/* MyFieldsControllerShared */

#import <Cocoa/Cocoa.h>

@class MyTableView;

@interface MyFieldsControllerShared : NSObject <NSTableViewDelegate, NSTableViewDataSource>
{    
	@public
	NSArray *personalFields;

	NSBundle *mainBundle;
	
	//NSArray *allColumns;
	NSDictionary *columnWidthDictionary;
	
	NSMutableArray *editFields;//, *allFields;
	//NSMutableArray *detailsFields;
	
	NSTableView *preferenceFieldsTable;
	NSTableColumn *locationColumn;
	int fieldTableMode;
	NSMutableArray *tableFieldsArray;
	NSMutableArray *preferenceArray, *detailsArray, *fullscreenArray;
	
	BOOL addPanelNeedsReset;
	NSMutableDictionary *customFieldNames;
}

- (BOOL)isFieldActive:(NSString *)aFieldIdentifier;
- (MKField)fieldTypeForIdentifier:(NSString *)aFieldIdentifier;

- (NSTableColumn *)addColumnWithIdentifier:(NSString *)nextColumnIdent width:(float)columnWidth toTable:(MyTableView *)aTableView;
- (NSArray *)editFields;
- (NSMutableArray *)allFields;
- (NSMutableArray *)editFieldsSorted;
- (NSMutableArray *)columnFields;
- (NSMutableArray *)smartCollectionFields;
- (NSMutableArray *)detailsFields;
- (NSArray *)personalFields;
- (NSMutableArray *)autofillFields;
- (NSArray *)fullScreenFields;
- (NSArray *)defaultFullscreenFields;
- (NSArray *)rssDescriptionFields;
- (NSArray *)filterMenuItems;

- (NSString *)locationForIdentifier:(NSString *)anIdentifier;
- (void)setEditFields:(NSMutableArray *)anArray;

//subclass

- (BOOL)isCustomField:(NSString *)aColumnIdent;
- (NSString *)customFieldWithTitle:(NSString *)possibleTitle;
- (NSString *)customCheckBoxithTitle:(NSString *)possibleTitle;
- (MKColumnType)columnType:(NSString *)columnIdentfier separateNumber:(BOOL)numberFields;
- (MKColumnType)columnTypeForObject:(id)anObject;
- (float)widthForColumn:(NSString *)aColumnIdent;
- (NSString *)localizedColumnName:(NSString *)aColumnIdent;

//Setters
- (void)initializeFieldsPreferenceTable:(NSTableView *)aTable;
- (BOOL)doesAddPanelNeedReset;
- (void)loadCustomFieldNamesCordinator:(NSPersistentStoreCoordinator *)psc;

@end
